<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAddOnFeatureInfo ArrayType
 * @subpackage Arrays
 */
class ArrayOfAddOnFeatureInfo extends AbstractStructArrayBase
{
    /**
     * The AddOnFeatureInfo
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AddOnFeatureInfo[]
     */
    public $AddOnFeatureInfo;
    /**
     * Constructor method for ArrayOfAddOnFeatureInfo
     * @uses ArrayOfAddOnFeatureInfo::setAddOnFeatureInfo()
     * @param \StructType\AddOnFeatureInfo[] $addOnFeatureInfo
     */
    public function __construct(array $addOnFeatureInfo = array())
    {
        $this
            ->setAddOnFeatureInfo($addOnFeatureInfo);
    }
    /**
     * Get AddOnFeatureInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AddOnFeatureInfo[]|null
     */
    public function getAddOnFeatureInfo()
    {
        return isset($this->AddOnFeatureInfo) ? $this->AddOnFeatureInfo : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAddOnFeatureInfo method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAddOnFeatureInfo method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAddOnFeatureInfoForArrayConstraintsFromSetAddOnFeatureInfo(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAddOnFeatureInfoAddOnFeatureInfoItem) {
            // validation for constraint: itemType
            if (!$arrayOfAddOnFeatureInfoAddOnFeatureInfoItem instanceof \StructType\AddOnFeatureInfo) {
                $invalidValues[] = is_object($arrayOfAddOnFeatureInfoAddOnFeatureInfoItem) ? get_class($arrayOfAddOnFeatureInfoAddOnFeatureInfoItem) : sprintf('%s(%s)', gettype($arrayOfAddOnFeatureInfoAddOnFeatureInfoItem), var_export($arrayOfAddOnFeatureInfoAddOnFeatureInfoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AddOnFeatureInfo property can only contain items of type \StructType\AddOnFeatureInfo, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AddOnFeatureInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AddOnFeatureInfo[] $addOnFeatureInfo
     * @return \ArrayType\ArrayOfAddOnFeatureInfo
     */
    public function setAddOnFeatureInfo(array $addOnFeatureInfo = array())
    {
        // validation for constraint: array
        if ('' !== ($addOnFeatureInfoArrayErrorMessage = self::validateAddOnFeatureInfoForArrayConstraintsFromSetAddOnFeatureInfo($addOnFeatureInfo))) {
            throw new \InvalidArgumentException($addOnFeatureInfoArrayErrorMessage, __LINE__);
        }
        if (is_null($addOnFeatureInfo) || (is_array($addOnFeatureInfo) && empty($addOnFeatureInfo))) {
            unset($this->AddOnFeatureInfo);
        } else {
            $this->AddOnFeatureInfo = $addOnFeatureInfo;
        }
        return $this;
    }
    /**
     * Add item to AddOnFeatureInfo value
     * @throws \InvalidArgumentException
     * @param \StructType\AddOnFeatureInfo $item
     * @return \ArrayType\ArrayOfAddOnFeatureInfo
     */
    public function addToAddOnFeatureInfo(\StructType\AddOnFeatureInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AddOnFeatureInfo) {
            throw new \InvalidArgumentException(sprintf('The AddOnFeatureInfo property can only contain items of type \StructType\AddOnFeatureInfo, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AddOnFeatureInfo[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AddOnFeatureInfo|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AddOnFeatureInfo|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AddOnFeatureInfo|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AddOnFeatureInfo|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AddOnFeatureInfo|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AddOnFeatureInfo
     */
    public function getAttributeName()
    {
        return 'AddOnFeatureInfo';
    }
}
