<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfBuilderProgramInfo ArrayType
 * @subpackage Arrays
 */
class ArrayOfBuilderProgramInfo extends AbstractStructArrayBase
{
    /**
     * The BuilderProgramInfo
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\BuilderProgramInfo[]
     */
    public $BuilderProgramInfo;
    /**
     * Constructor method for ArrayOfBuilderProgramInfo
     * @uses ArrayOfBuilderProgramInfo::setBuilderProgramInfo()
     * @param \StructType\BuilderProgramInfo[] $builderProgramInfo
     */
    public function __construct(array $builderProgramInfo = array())
    {
        $this
            ->setBuilderProgramInfo($builderProgramInfo);
    }
    /**
     * Get BuilderProgramInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\BuilderProgramInfo[]|null
     */
    public function getBuilderProgramInfo()
    {
        return isset($this->BuilderProgramInfo) ? $this->BuilderProgramInfo : null;
    }
    /**
     * This method is responsible for validating the values passed to the setBuilderProgramInfo method
     * This method is willingly generated in order to preserve the one-line inline validation within the setBuilderProgramInfo method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateBuilderProgramInfoForArrayConstraintsFromSetBuilderProgramInfo(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfBuilderProgramInfoBuilderProgramInfoItem) {
            // validation for constraint: itemType
            if (!$arrayOfBuilderProgramInfoBuilderProgramInfoItem instanceof \StructType\BuilderProgramInfo) {
                $invalidValues[] = is_object($arrayOfBuilderProgramInfoBuilderProgramInfoItem) ? get_class($arrayOfBuilderProgramInfoBuilderProgramInfoItem) : sprintf('%s(%s)', gettype($arrayOfBuilderProgramInfoBuilderProgramInfoItem), var_export($arrayOfBuilderProgramInfoBuilderProgramInfoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The BuilderProgramInfo property can only contain items of type \StructType\BuilderProgramInfo, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set BuilderProgramInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\BuilderProgramInfo[] $builderProgramInfo
     * @return \ArrayType\ArrayOfBuilderProgramInfo
     */
    public function setBuilderProgramInfo(array $builderProgramInfo = array())
    {
        // validation for constraint: array
        if ('' !== ($builderProgramInfoArrayErrorMessage = self::validateBuilderProgramInfoForArrayConstraintsFromSetBuilderProgramInfo($builderProgramInfo))) {
            throw new \InvalidArgumentException($builderProgramInfoArrayErrorMessage, __LINE__);
        }
        if (is_null($builderProgramInfo) || (is_array($builderProgramInfo) && empty($builderProgramInfo))) {
            unset($this->BuilderProgramInfo);
        } else {
            $this->BuilderProgramInfo = $builderProgramInfo;
        }
        return $this;
    }
    /**
     * Add item to BuilderProgramInfo value
     * @throws \InvalidArgumentException
     * @param \StructType\BuilderProgramInfo $item
     * @return \ArrayType\ArrayOfBuilderProgramInfo
     */
    public function addToBuilderProgramInfo(\StructType\BuilderProgramInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\BuilderProgramInfo) {
            throw new \InvalidArgumentException(sprintf('The BuilderProgramInfo property can only contain items of type \StructType\BuilderProgramInfo, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->BuilderProgramInfo[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\BuilderProgramInfo|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\BuilderProgramInfo|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\BuilderProgramInfo|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\BuilderProgramInfo|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\BuilderProgramInfo|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string BuilderProgramInfo
     */
    public function getAttributeName()
    {
        return 'BuilderProgramInfo';
    }
}
