<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCustomerRepDepartmentEnum ArrayType
 * @subpackage Arrays
 */
class ArrayOfCustomerRepDepartmentEnum extends AbstractStructArrayBase
{
    /**
     * The CustomerRepDepartmentEnum
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var string[]
     */
    public $CustomerRepDepartmentEnum;
    /**
     * Constructor method for ArrayOfCustomerRepDepartmentEnum
     * @uses ArrayOfCustomerRepDepartmentEnum::setCustomerRepDepartmentEnum()
     * @param string[] $customerRepDepartmentEnum
     */
    public function __construct(array $customerRepDepartmentEnum = array())
    {
        $this
            ->setCustomerRepDepartmentEnum($customerRepDepartmentEnum);
    }
    /**
     * Get CustomerRepDepartmentEnum value
     * @return string[]|null
     */
    public function getCustomerRepDepartmentEnum()
    {
        return $this->CustomerRepDepartmentEnum;
    }
    /**
     * This method is responsible for validating the values passed to the setCustomerRepDepartmentEnum method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCustomerRepDepartmentEnum method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCustomerRepDepartmentEnumForArrayConstraintsFromSetCustomerRepDepartmentEnum(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfCustomerRepDepartmentEnumCustomerRepDepartmentEnumItem) {
            // validation for constraint: enumeration
            if (!\EnumType\CustomerRepDepartmentEnum::valueIsValid($arrayOfCustomerRepDepartmentEnumCustomerRepDepartmentEnumItem)) {
                $invalidValues[] = is_object($arrayOfCustomerRepDepartmentEnumCustomerRepDepartmentEnumItem) ? get_class($arrayOfCustomerRepDepartmentEnumCustomerRepDepartmentEnumItem) : sprintf('%s(%s)', gettype($arrayOfCustomerRepDepartmentEnumCustomerRepDepartmentEnumItem), var_export($arrayOfCustomerRepDepartmentEnumCustomerRepDepartmentEnumItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\CustomerRepDepartmentEnum', is_array($invalidValues) ? implode(', ', $invalidValues) : var_export($invalidValues, true), implode(', ', \EnumType\CustomerRepDepartmentEnum::getValidValues()));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CustomerRepDepartmentEnum value
     * @uses \EnumType\CustomerRepDepartmentEnum::valueIsValid()
     * @uses \EnumType\CustomerRepDepartmentEnum::getValidValues()
     * @throws \InvalidArgumentException
     * @param string[] $customerRepDepartmentEnum
     * @return \ArrayType\ArrayOfCustomerRepDepartmentEnum
     */
    public function setCustomerRepDepartmentEnum(array $customerRepDepartmentEnum = array())
    {
        // validation for constraint: array
        if ('' !== ($customerRepDepartmentEnumArrayErrorMessage = self::validateCustomerRepDepartmentEnumForArrayConstraintsFromSetCustomerRepDepartmentEnum($customerRepDepartmentEnum))) {
            throw new \InvalidArgumentException($customerRepDepartmentEnumArrayErrorMessage, __LINE__);
        }
        $this->CustomerRepDepartmentEnum = $customerRepDepartmentEnum;
        return $this;
    }
    /**
     * Add item to CustomerRepDepartmentEnum value
     * @uses \EnumType\CustomerRepDepartmentEnum::valueIsValid()
     * @uses \EnumType\CustomerRepDepartmentEnum::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \ArrayType\ArrayOfCustomerRepDepartmentEnum
     */
    public function addToCustomerRepDepartmentEnum($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\CustomerRepDepartmentEnum::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\CustomerRepDepartmentEnum', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\CustomerRepDepartmentEnum::getValidValues())), __LINE__);
        }
        $this->CustomerRepDepartmentEnum[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return string|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return string|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return string|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return string|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return string|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Add element to array
     * @see AbstractStructArrayBase::add()
     * @throws \InvalidArgumentException
     * @uses \EnumType\CustomerRepDepartmentEnum::valueIsValid()
     * @param string $item
     * @return \ArrayType\ArrayOfCustomerRepDepartmentEnum
     */
    public function add($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\CustomerRepDepartmentEnum::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\CustomerRepDepartmentEnum', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\CustomerRepDepartmentEnum::getValidValues())), __LINE__);
        }
        return parent::add($item);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CustomerRepDepartmentEnum
     */
    public function getAttributeName()
    {
        return 'CustomerRepDepartmentEnum';
    }
}
