<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDealerCustomUpload ArrayType
 * @subpackage Arrays
 */
class ArrayOfDealerCustomUpload extends AbstractStructArrayBase
{
    /**
     * The DealerCustomUpload
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DealerCustomUpload[]
     */
    public $DealerCustomUpload;
    /**
     * Constructor method for ArrayOfDealerCustomUpload
     * @uses ArrayOfDealerCustomUpload::setDealerCustomUpload()
     * @param \StructType\DealerCustomUpload[] $dealerCustomUpload
     */
    public function __construct(array $dealerCustomUpload = array())
    {
        $this
            ->setDealerCustomUpload($dealerCustomUpload);
    }
    /**
     * Get DealerCustomUpload value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DealerCustomUpload[]|null
     */
    public function getDealerCustomUpload()
    {
        return isset($this->DealerCustomUpload) ? $this->DealerCustomUpload : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDealerCustomUpload method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDealerCustomUpload method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDealerCustomUploadForArrayConstraintsFromSetDealerCustomUpload(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDealerCustomUploadDealerCustomUploadItem) {
            // validation for constraint: itemType
            if (!$arrayOfDealerCustomUploadDealerCustomUploadItem instanceof \StructType\DealerCustomUpload) {
                $invalidValues[] = is_object($arrayOfDealerCustomUploadDealerCustomUploadItem) ? get_class($arrayOfDealerCustomUploadDealerCustomUploadItem) : sprintf('%s(%s)', gettype($arrayOfDealerCustomUploadDealerCustomUploadItem), var_export($arrayOfDealerCustomUploadDealerCustomUploadItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DealerCustomUpload property can only contain items of type \StructType\DealerCustomUpload, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DealerCustomUpload value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DealerCustomUpload[] $dealerCustomUpload
     * @return \ArrayType\ArrayOfDealerCustomUpload
     */
    public function setDealerCustomUpload(array $dealerCustomUpload = array())
    {
        // validation for constraint: array
        if ('' !== ($dealerCustomUploadArrayErrorMessage = self::validateDealerCustomUploadForArrayConstraintsFromSetDealerCustomUpload($dealerCustomUpload))) {
            throw new \InvalidArgumentException($dealerCustomUploadArrayErrorMessage, __LINE__);
        }
        if (is_null($dealerCustomUpload) || (is_array($dealerCustomUpload) && empty($dealerCustomUpload))) {
            unset($this->DealerCustomUpload);
        } else {
            $this->DealerCustomUpload = $dealerCustomUpload;
        }
        return $this;
    }
    /**
     * Add item to DealerCustomUpload value
     * @throws \InvalidArgumentException
     * @param \StructType\DealerCustomUpload $item
     * @return \ArrayType\ArrayOfDealerCustomUpload
     */
    public function addToDealerCustomUpload(\StructType\DealerCustomUpload $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DealerCustomUpload) {
            throw new \InvalidArgumentException(sprintf('The DealerCustomUpload property can only contain items of type \StructType\DealerCustomUpload, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DealerCustomUpload[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DealerCustomUpload|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DealerCustomUpload|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DealerCustomUpload|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DealerCustomUpload|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DealerCustomUpload|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DealerCustomUpload
     */
    public function getAttributeName()
    {
        return 'DealerCustomUpload';
    }
}
