<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDealerMarketingEmailPreferenceEnum ArrayType
 * @subpackage Arrays
 */
class ArrayOfDealerMarketingEmailPreferenceEnum extends AbstractStructArrayBase
{
    /**
     * The DealerMarketingEmailPreferenceEnum
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var string[]
     */
    public $DealerMarketingEmailPreferenceEnum;
    /**
     * Constructor method for ArrayOfDealerMarketingEmailPreferenceEnum
     * @uses ArrayOfDealerMarketingEmailPreferenceEnum::setDealerMarketingEmailPreferenceEnum()
     * @param string[] $dealerMarketingEmailPreferenceEnum
     */
    public function __construct(array $dealerMarketingEmailPreferenceEnum = array())
    {
        $this
            ->setDealerMarketingEmailPreferenceEnum($dealerMarketingEmailPreferenceEnum);
    }
    /**
     * Get DealerMarketingEmailPreferenceEnum value
     * @return string[]|null
     */
    public function getDealerMarketingEmailPreferenceEnum()
    {
        return $this->DealerMarketingEmailPreferenceEnum;
    }
    /**
     * This method is responsible for validating the values passed to the setDealerMarketingEmailPreferenceEnum method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDealerMarketingEmailPreferenceEnum method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDealerMarketingEmailPreferenceEnumForArrayConstraintsFromSetDealerMarketingEmailPreferenceEnum(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDealerMarketingEmailPreferenceEnumDealerMarketingEmailPreferenceEnumItem) {
            // validation for constraint: enumeration
            if (!\EnumType\DealerMarketingEmailPreferenceEnum::valueIsValid($arrayOfDealerMarketingEmailPreferenceEnumDealerMarketingEmailPreferenceEnumItem)) {
                $invalidValues[] = is_object($arrayOfDealerMarketingEmailPreferenceEnumDealerMarketingEmailPreferenceEnumItem) ? get_class($arrayOfDealerMarketingEmailPreferenceEnumDealerMarketingEmailPreferenceEnumItem) : sprintf('%s(%s)', gettype($arrayOfDealerMarketingEmailPreferenceEnumDealerMarketingEmailPreferenceEnumItem), var_export($arrayOfDealerMarketingEmailPreferenceEnumDealerMarketingEmailPreferenceEnumItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\DealerMarketingEmailPreferenceEnum', is_array($invalidValues) ? implode(', ', $invalidValues) : var_export($invalidValues, true), implode(', ', \EnumType\DealerMarketingEmailPreferenceEnum::getValidValues()));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DealerMarketingEmailPreferenceEnum value
     * @uses \EnumType\DealerMarketingEmailPreferenceEnum::valueIsValid()
     * @uses \EnumType\DealerMarketingEmailPreferenceEnum::getValidValues()
     * @throws \InvalidArgumentException
     * @param string[] $dealerMarketingEmailPreferenceEnum
     * @return \ArrayType\ArrayOfDealerMarketingEmailPreferenceEnum
     */
    public function setDealerMarketingEmailPreferenceEnum(array $dealerMarketingEmailPreferenceEnum = array())
    {
        // validation for constraint: array
        if ('' !== ($dealerMarketingEmailPreferenceEnumArrayErrorMessage = self::validateDealerMarketingEmailPreferenceEnumForArrayConstraintsFromSetDealerMarketingEmailPreferenceEnum($dealerMarketingEmailPreferenceEnum))) {
            throw new \InvalidArgumentException($dealerMarketingEmailPreferenceEnumArrayErrorMessage, __LINE__);
        }
        $this->DealerMarketingEmailPreferenceEnum = $dealerMarketingEmailPreferenceEnum;
        return $this;
    }
    /**
     * Add item to DealerMarketingEmailPreferenceEnum value
     * @uses \EnumType\DealerMarketingEmailPreferenceEnum::valueIsValid()
     * @uses \EnumType\DealerMarketingEmailPreferenceEnum::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \ArrayType\ArrayOfDealerMarketingEmailPreferenceEnum
     */
    public function addToDealerMarketingEmailPreferenceEnum($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\DealerMarketingEmailPreferenceEnum::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\DealerMarketingEmailPreferenceEnum', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\DealerMarketingEmailPreferenceEnum::getValidValues())), __LINE__);
        }
        $this->DealerMarketingEmailPreferenceEnum[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return string|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return string|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return string|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return string|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return string|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Add element to array
     * @see AbstractStructArrayBase::add()
     * @throws \InvalidArgumentException
     * @uses \EnumType\DealerMarketingEmailPreferenceEnum::valueIsValid()
     * @param string $item
     * @return \ArrayType\ArrayOfDealerMarketingEmailPreferenceEnum
     */
    public function add($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\DealerMarketingEmailPreferenceEnum::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\DealerMarketingEmailPreferenceEnum', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\DealerMarketingEmailPreferenceEnum::getValidValues())), __LINE__);
        }
        return parent::add($item);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DealerMarketingEmailPreferenceEnum
     */
    public function getAttributeName()
    {
        return 'DealerMarketingEmailPreferenceEnum';
    }
}
