<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfMyBinderResourceItemModel ArrayType
 * @subpackage Arrays
 */
class ArrayOfMyBinderResourceItemModel extends AbstractStructArrayBase
{
    /**
     * The MyBinderResourceItemModel
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\MyBinderResourceItemModel[]
     */
    public $MyBinderResourceItemModel;
    /**
     * Constructor method for ArrayOfMyBinderResourceItemModel
     * @uses ArrayOfMyBinderResourceItemModel::setMyBinderResourceItemModel()
     * @param \StructType\MyBinderResourceItemModel[] $myBinderResourceItemModel
     */
    public function __construct(array $myBinderResourceItemModel = array())
    {
        $this
            ->setMyBinderResourceItemModel($myBinderResourceItemModel);
    }
    /**
     * Get MyBinderResourceItemModel value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\MyBinderResourceItemModel[]|null
     */
    public function getMyBinderResourceItemModel()
    {
        return isset($this->MyBinderResourceItemModel) ? $this->MyBinderResourceItemModel : null;
    }
    /**
     * This method is responsible for validating the values passed to the setMyBinderResourceItemModel method
     * This method is willingly generated in order to preserve the one-line inline validation within the setMyBinderResourceItemModel method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateMyBinderResourceItemModelForArrayConstraintsFromSetMyBinderResourceItemModel(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfMyBinderResourceItemModelMyBinderResourceItemModelItem) {
            // validation for constraint: itemType
            if (!$arrayOfMyBinderResourceItemModelMyBinderResourceItemModelItem instanceof \StructType\MyBinderResourceItemModel) {
                $invalidValues[] = is_object($arrayOfMyBinderResourceItemModelMyBinderResourceItemModelItem) ? get_class($arrayOfMyBinderResourceItemModelMyBinderResourceItemModelItem) : sprintf('%s(%s)', gettype($arrayOfMyBinderResourceItemModelMyBinderResourceItemModelItem), var_export($arrayOfMyBinderResourceItemModelMyBinderResourceItemModelItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The MyBinderResourceItemModel property can only contain items of type \StructType\MyBinderResourceItemModel, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set MyBinderResourceItemModel value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\MyBinderResourceItemModel[] $myBinderResourceItemModel
     * @return \ArrayType\ArrayOfMyBinderResourceItemModel
     */
    public function setMyBinderResourceItemModel(array $myBinderResourceItemModel = array())
    {
        // validation for constraint: array
        if ('' !== ($myBinderResourceItemModelArrayErrorMessage = self::validateMyBinderResourceItemModelForArrayConstraintsFromSetMyBinderResourceItemModel($myBinderResourceItemModel))) {
            throw new \InvalidArgumentException($myBinderResourceItemModelArrayErrorMessage, __LINE__);
        }
        if (is_null($myBinderResourceItemModel) || (is_array($myBinderResourceItemModel) && empty($myBinderResourceItemModel))) {
            unset($this->MyBinderResourceItemModel);
        } else {
            $this->MyBinderResourceItemModel = $myBinderResourceItemModel;
        }
        return $this;
    }
    /**
     * Add item to MyBinderResourceItemModel value
     * @throws \InvalidArgumentException
     * @param \StructType\MyBinderResourceItemModel $item
     * @return \ArrayType\ArrayOfMyBinderResourceItemModel
     */
    public function addToMyBinderResourceItemModel(\StructType\MyBinderResourceItemModel $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\MyBinderResourceItemModel) {
            throw new \InvalidArgumentException(sprintf('The MyBinderResourceItemModel property can only contain items of type \StructType\MyBinderResourceItemModel, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->MyBinderResourceItemModel[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\MyBinderResourceItemModel|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\MyBinderResourceItemModel|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\MyBinderResourceItemModel|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\MyBinderResourceItemModel|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\MyBinderResourceItemModel|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string MyBinderResourceItemModel
     */
    public function getAttributeName()
    {
        return 'MyBinderResourceItemModel';
    }
}
