<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPanelTemplateInfo ArrayType
 * @subpackage Arrays
 */
class ArrayOfPanelTemplateInfo extends AbstractStructArrayBase
{
    /**
     * The PanelTemplateInfo
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PanelTemplateInfo[]
     */
    public $PanelTemplateInfo;
    /**
     * Constructor method for ArrayOfPanelTemplateInfo
     * @uses ArrayOfPanelTemplateInfo::setPanelTemplateInfo()
     * @param \StructType\PanelTemplateInfo[] $panelTemplateInfo
     */
    public function __construct(array $panelTemplateInfo = array())
    {
        $this
            ->setPanelTemplateInfo($panelTemplateInfo);
    }
    /**
     * Get PanelTemplateInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PanelTemplateInfo[]|null
     */
    public function getPanelTemplateInfo()
    {
        return isset($this->PanelTemplateInfo) ? $this->PanelTemplateInfo : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPanelTemplateInfo method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPanelTemplateInfo method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePanelTemplateInfoForArrayConstraintsFromSetPanelTemplateInfo(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPanelTemplateInfoPanelTemplateInfoItem) {
            // validation for constraint: itemType
            if (!$arrayOfPanelTemplateInfoPanelTemplateInfoItem instanceof \StructType\PanelTemplateInfo) {
                $invalidValues[] = is_object($arrayOfPanelTemplateInfoPanelTemplateInfoItem) ? get_class($arrayOfPanelTemplateInfoPanelTemplateInfoItem) : sprintf('%s(%s)', gettype($arrayOfPanelTemplateInfoPanelTemplateInfoItem), var_export($arrayOfPanelTemplateInfoPanelTemplateInfoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PanelTemplateInfo property can only contain items of type \StructType\PanelTemplateInfo, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PanelTemplateInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PanelTemplateInfo[] $panelTemplateInfo
     * @return \ArrayType\ArrayOfPanelTemplateInfo
     */
    public function setPanelTemplateInfo(array $panelTemplateInfo = array())
    {
        // validation for constraint: array
        if ('' !== ($panelTemplateInfoArrayErrorMessage = self::validatePanelTemplateInfoForArrayConstraintsFromSetPanelTemplateInfo($panelTemplateInfo))) {
            throw new \InvalidArgumentException($panelTemplateInfoArrayErrorMessage, __LINE__);
        }
        if (is_null($panelTemplateInfo) || (is_array($panelTemplateInfo) && empty($panelTemplateInfo))) {
            unset($this->PanelTemplateInfo);
        } else {
            $this->PanelTemplateInfo = $panelTemplateInfo;
        }
        return $this;
    }
    /**
     * Add item to PanelTemplateInfo value
     * @throws \InvalidArgumentException
     * @param \StructType\PanelTemplateInfo $item
     * @return \ArrayType\ArrayOfPanelTemplateInfo
     */
    public function addToPanelTemplateInfo(\StructType\PanelTemplateInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PanelTemplateInfo) {
            throw new \InvalidArgumentException(sprintf('The PanelTemplateInfo property can only contain items of type \StructType\PanelTemplateInfo, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PanelTemplateInfo[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PanelTemplateInfo|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PanelTemplateInfo|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PanelTemplateInfo|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PanelTemplateInfo|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PanelTemplateInfo|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PanelTemplateInfo
     */
    public function getAttributeName()
    {
        return 'PanelTemplateInfo';
    }
}
