<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPanelTypeEnum ArrayType
 * @subpackage Arrays
 */
class ArrayOfPanelTypeEnum extends AbstractStructArrayBase
{
    /**
     * The PanelTypeEnum
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var string[]
     */
    public $PanelTypeEnum;
    /**
     * Constructor method for ArrayOfPanelTypeEnum
     * @uses ArrayOfPanelTypeEnum::setPanelTypeEnum()
     * @param string[] $panelTypeEnum
     */
    public function __construct(array $panelTypeEnum = array())
    {
        $this
            ->setPanelTypeEnum($panelTypeEnum);
    }
    /**
     * Get PanelTypeEnum value
     * @return string[]|null
     */
    public function getPanelTypeEnum()
    {
        return $this->PanelTypeEnum;
    }
    /**
     * This method is responsible for validating the values passed to the setPanelTypeEnum method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPanelTypeEnum method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePanelTypeEnumForArrayConstraintsFromSetPanelTypeEnum(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPanelTypeEnumPanelTypeEnumItem) {
            // validation for constraint: enumeration
            if (!\EnumType\PanelTypeEnum::valueIsValid($arrayOfPanelTypeEnumPanelTypeEnumItem)) {
                $invalidValues[] = is_object($arrayOfPanelTypeEnumPanelTypeEnumItem) ? get_class($arrayOfPanelTypeEnumPanelTypeEnumItem) : sprintf('%s(%s)', gettype($arrayOfPanelTypeEnumPanelTypeEnumItem), var_export($arrayOfPanelTypeEnumPanelTypeEnumItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\PanelTypeEnum', is_array($invalidValues) ? implode(', ', $invalidValues) : var_export($invalidValues, true), implode(', ', \EnumType\PanelTypeEnum::getValidValues()));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PanelTypeEnum value
     * @uses \EnumType\PanelTypeEnum::valueIsValid()
     * @uses \EnumType\PanelTypeEnum::getValidValues()
     * @throws \InvalidArgumentException
     * @param string[] $panelTypeEnum
     * @return \ArrayType\ArrayOfPanelTypeEnum
     */
    public function setPanelTypeEnum(array $panelTypeEnum = array())
    {
        // validation for constraint: array
        if ('' !== ($panelTypeEnumArrayErrorMessage = self::validatePanelTypeEnumForArrayConstraintsFromSetPanelTypeEnum($panelTypeEnum))) {
            throw new \InvalidArgumentException($panelTypeEnumArrayErrorMessage, __LINE__);
        }
        $this->PanelTypeEnum = $panelTypeEnum;
        return $this;
    }
    /**
     * Add item to PanelTypeEnum value
     * @uses \EnumType\PanelTypeEnum::valueIsValid()
     * @uses \EnumType\PanelTypeEnum::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \ArrayType\ArrayOfPanelTypeEnum
     */
    public function addToPanelTypeEnum($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\PanelTypeEnum::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\PanelTypeEnum', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\PanelTypeEnum::getValidValues())), __LINE__);
        }
        $this->PanelTypeEnum[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return string|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return string|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return string|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return string|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return string|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Add element to array
     * @see AbstractStructArrayBase::add()
     * @throws \InvalidArgumentException
     * @uses \EnumType\PanelTypeEnum::valueIsValid()
     * @param string $item
     * @return \ArrayType\ArrayOfPanelTypeEnum
     */
    public function add($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\PanelTypeEnum::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\PanelTypeEnum', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\PanelTypeEnum::getValidValues())), __LINE__);
        }
        return parent::add($item);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PanelTypeEnum
     */
    public function getAttributeName()
    {
        return 'PanelTypeEnum';
    }
}
