<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfRep ArrayType
 * @subpackage Arrays
 */
class ArrayOfRep extends AbstractStructArrayBase
{
    /**
     * The Rep
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Rep[]
     */
    public $Rep;
    /**
     * Constructor method for ArrayOfRep
     * @uses ArrayOfRep::setRep()
     * @param \StructType\Rep[] $rep
     */
    public function __construct(array $rep = array())
    {
        $this
            ->setRep($rep);
    }
    /**
     * Get Rep value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Rep[]|null
     */
    public function getRep()
    {
        return isset($this->Rep) ? $this->Rep : null;
    }
    /**
     * This method is responsible for validating the values passed to the setRep method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRep method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRepForArrayConstraintsFromSetRep(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfRepRepItem) {
            // validation for constraint: itemType
            if (!$arrayOfRepRepItem instanceof \StructType\Rep) {
                $invalidValues[] = is_object($arrayOfRepRepItem) ? get_class($arrayOfRepRepItem) : sprintf('%s(%s)', gettype($arrayOfRepRepItem), var_export($arrayOfRepRepItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Rep property can only contain items of type \StructType\Rep, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Rep value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\Rep[] $rep
     * @return \ArrayType\ArrayOfRep
     */
    public function setRep(array $rep = array())
    {
        // validation for constraint: array
        if ('' !== ($repArrayErrorMessage = self::validateRepForArrayConstraintsFromSetRep($rep))) {
            throw new \InvalidArgumentException($repArrayErrorMessage, __LINE__);
        }
        if (is_null($rep) || (is_array($rep) && empty($rep))) {
            unset($this->Rep);
        } else {
            $this->Rep = $rep;
        }
        return $this;
    }
    /**
     * Add item to Rep value
     * @throws \InvalidArgumentException
     * @param \StructType\Rep $item
     * @return \ArrayType\ArrayOfRep
     */
    public function addToRep(\StructType\Rep $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Rep) {
            throw new \InvalidArgumentException(sprintf('The Rep property can only contain items of type \StructType\Rep, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Rep[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\Rep|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\Rep|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\Rep|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\Rep|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\Rep|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Rep
     */
    public function getAttributeName()
    {
        return 'Rep';
    }
}
