<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfWsCSPhone ArrayType
 * @subpackage Arrays
 */
class ArrayOfWsCSPhone extends AbstractStructArrayBase
{
    /**
     * The WsCSPhone
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\WsCSPhone[]
     */
    public $WsCSPhone;
    /**
     * Constructor method for ArrayOfWsCSPhone
     * @uses ArrayOfWsCSPhone::setWsCSPhone()
     * @param \StructType\WsCSPhone[] $wsCSPhone
     */
    public function __construct(array $wsCSPhone = array())
    {
        $this
            ->setWsCSPhone($wsCSPhone);
    }
    /**
     * Get WsCSPhone value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\WsCSPhone[]|null
     */
    public function getWsCSPhone()
    {
        return isset($this->WsCSPhone) ? $this->WsCSPhone : null;
    }
    /**
     * This method is responsible for validating the values passed to the setWsCSPhone method
     * This method is willingly generated in order to preserve the one-line inline validation within the setWsCSPhone method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateWsCSPhoneForArrayConstraintsFromSetWsCSPhone(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfWsCSPhoneWsCSPhoneItem) {
            // validation for constraint: itemType
            if (!$arrayOfWsCSPhoneWsCSPhoneItem instanceof \StructType\WsCSPhone) {
                $invalidValues[] = is_object($arrayOfWsCSPhoneWsCSPhoneItem) ? get_class($arrayOfWsCSPhoneWsCSPhoneItem) : sprintf('%s(%s)', gettype($arrayOfWsCSPhoneWsCSPhoneItem), var_export($arrayOfWsCSPhoneWsCSPhoneItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The WsCSPhone property can only contain items of type \StructType\WsCSPhone, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set WsCSPhone value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\WsCSPhone[] $wsCSPhone
     * @return \ArrayType\ArrayOfWsCSPhone
     */
    public function setWsCSPhone(array $wsCSPhone = array())
    {
        // validation for constraint: array
        if ('' !== ($wsCSPhoneArrayErrorMessage = self::validateWsCSPhoneForArrayConstraintsFromSetWsCSPhone($wsCSPhone))) {
            throw new \InvalidArgumentException($wsCSPhoneArrayErrorMessage, __LINE__);
        }
        if (is_null($wsCSPhone) || (is_array($wsCSPhone) && empty($wsCSPhone))) {
            unset($this->WsCSPhone);
        } else {
            $this->WsCSPhone = $wsCSPhone;
        }
        return $this;
    }
    /**
     * Add item to WsCSPhone value
     * @throws \InvalidArgumentException
     * @param \StructType\WsCSPhone $item
     * @return \ArrayType\ArrayOfWsCSPhone
     */
    public function addToWsCSPhone(\StructType\WsCSPhone $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\WsCSPhone) {
            throw new \InvalidArgumentException(sprintf('The WsCSPhone property can only contain items of type \StructType\WsCSPhone, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->WsCSPhone[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\WsCSPhone|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\WsCSPhone|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\WsCSPhone|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\WsCSPhone|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\WsCSPhone|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string WsCSPhone
     */
    public function getAttributeName()
    {
        return 'WsCSPhone';
    }
}
