<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfWsIssueCategory ArrayType
 * @subpackage Arrays
 */
class ArrayOfWsIssueCategory extends AbstractStructArrayBase
{
    /**
     * The WsIssueCategory
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\WsIssueCategory[]
     */
    public $WsIssueCategory;
    /**
     * Constructor method for ArrayOfWsIssueCategory
     * @uses ArrayOfWsIssueCategory::setWsIssueCategory()
     * @param \StructType\WsIssueCategory[] $wsIssueCategory
     */
    public function __construct(array $wsIssueCategory = array())
    {
        $this
            ->setWsIssueCategory($wsIssueCategory);
    }
    /**
     * Get WsIssueCategory value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\WsIssueCategory[]|null
     */
    public function getWsIssueCategory()
    {
        return isset($this->WsIssueCategory) ? $this->WsIssueCategory : null;
    }
    /**
     * This method is responsible for validating the values passed to the setWsIssueCategory method
     * This method is willingly generated in order to preserve the one-line inline validation within the setWsIssueCategory method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateWsIssueCategoryForArrayConstraintsFromSetWsIssueCategory(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfWsIssueCategoryWsIssueCategoryItem) {
            // validation for constraint: itemType
            if (!$arrayOfWsIssueCategoryWsIssueCategoryItem instanceof \StructType\WsIssueCategory) {
                $invalidValues[] = is_object($arrayOfWsIssueCategoryWsIssueCategoryItem) ? get_class($arrayOfWsIssueCategoryWsIssueCategoryItem) : sprintf('%s(%s)', gettype($arrayOfWsIssueCategoryWsIssueCategoryItem), var_export($arrayOfWsIssueCategoryWsIssueCategoryItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The WsIssueCategory property can only contain items of type \StructType\WsIssueCategory, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set WsIssueCategory value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\WsIssueCategory[] $wsIssueCategory
     * @return \ArrayType\ArrayOfWsIssueCategory
     */
    public function setWsIssueCategory(array $wsIssueCategory = array())
    {
        // validation for constraint: array
        if ('' !== ($wsIssueCategoryArrayErrorMessage = self::validateWsIssueCategoryForArrayConstraintsFromSetWsIssueCategory($wsIssueCategory))) {
            throw new \InvalidArgumentException($wsIssueCategoryArrayErrorMessage, __LINE__);
        }
        if (is_null($wsIssueCategory) || (is_array($wsIssueCategory) && empty($wsIssueCategory))) {
            unset($this->WsIssueCategory);
        } else {
            $this->WsIssueCategory = $wsIssueCategory;
        }
        return $this;
    }
    /**
     * Add item to WsIssueCategory value
     * @throws \InvalidArgumentException
     * @param \StructType\WsIssueCategory $item
     * @return \ArrayType\ArrayOfWsIssueCategory
     */
    public function addToWsIssueCategory(\StructType\WsIssueCategory $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\WsIssueCategory) {
            throw new \InvalidArgumentException(sprintf('The WsIssueCategory property can only contain items of type \StructType\WsIssueCategory, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->WsIssueCategory[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\WsIssueCategory|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\WsIssueCategory|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\WsIssueCategory|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\WsIssueCategory|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\WsIssueCategory|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string WsIssueCategory
     */
    public function getAttributeName()
    {
        return 'WsIssueCategory';
    }
}
