<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfWsIssueComment ArrayType
 * @subpackage Arrays
 */
class ArrayOfWsIssueComment extends AbstractStructArrayBase
{
    /**
     * The WsIssueComment
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\WsIssueComment[]
     */
    public $WsIssueComment;
    /**
     * Constructor method for ArrayOfWsIssueComment
     * @uses ArrayOfWsIssueComment::setWsIssueComment()
     * @param \StructType\WsIssueComment[] $wsIssueComment
     */
    public function __construct(array $wsIssueComment = array())
    {
        $this
            ->setWsIssueComment($wsIssueComment);
    }
    /**
     * Get WsIssueComment value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\WsIssueComment[]|null
     */
    public function getWsIssueComment()
    {
        return isset($this->WsIssueComment) ? $this->WsIssueComment : null;
    }
    /**
     * This method is responsible for validating the values passed to the setWsIssueComment method
     * This method is willingly generated in order to preserve the one-line inline validation within the setWsIssueComment method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateWsIssueCommentForArrayConstraintsFromSetWsIssueComment(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfWsIssueCommentWsIssueCommentItem) {
            // validation for constraint: itemType
            if (!$arrayOfWsIssueCommentWsIssueCommentItem instanceof \StructType\WsIssueComment) {
                $invalidValues[] = is_object($arrayOfWsIssueCommentWsIssueCommentItem) ? get_class($arrayOfWsIssueCommentWsIssueCommentItem) : sprintf('%s(%s)', gettype($arrayOfWsIssueCommentWsIssueCommentItem), var_export($arrayOfWsIssueCommentWsIssueCommentItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The WsIssueComment property can only contain items of type \StructType\WsIssueComment, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set WsIssueComment value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\WsIssueComment[] $wsIssueComment
     * @return \ArrayType\ArrayOfWsIssueComment
     */
    public function setWsIssueComment(array $wsIssueComment = array())
    {
        // validation for constraint: array
        if ('' !== ($wsIssueCommentArrayErrorMessage = self::validateWsIssueCommentForArrayConstraintsFromSetWsIssueComment($wsIssueComment))) {
            throw new \InvalidArgumentException($wsIssueCommentArrayErrorMessage, __LINE__);
        }
        if (is_null($wsIssueComment) || (is_array($wsIssueComment) && empty($wsIssueComment))) {
            unset($this->WsIssueComment);
        } else {
            $this->WsIssueComment = $wsIssueComment;
        }
        return $this;
    }
    /**
     * Add item to WsIssueComment value
     * @throws \InvalidArgumentException
     * @param \StructType\WsIssueComment $item
     * @return \ArrayType\ArrayOfWsIssueComment
     */
    public function addToWsIssueComment(\StructType\WsIssueComment $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\WsIssueComment) {
            throw new \InvalidArgumentException(sprintf('The WsIssueComment property can only contain items of type \StructType\WsIssueComment, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->WsIssueComment[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\WsIssueComment|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\WsIssueComment|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\WsIssueComment|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\WsIssueComment|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\WsIssueComment|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string WsIssueComment
     */
    public function getAttributeName()
    {
        return 'WsIssueComment';
    }
}
