<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfWsSupportTicket ArrayType
 * @subpackage Arrays
 */
class ArrayOfWsSupportTicket extends AbstractStructArrayBase
{
    /**
     * The WsSupportTicket
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\WsSupportTicket[]
     */
    public $WsSupportTicket;
    /**
     * Constructor method for ArrayOfWsSupportTicket
     * @uses ArrayOfWsSupportTicket::setWsSupportTicket()
     * @param \StructType\WsSupportTicket[] $wsSupportTicket
     */
    public function __construct(array $wsSupportTicket = array())
    {
        $this
            ->setWsSupportTicket($wsSupportTicket);
    }
    /**
     * Get WsSupportTicket value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\WsSupportTicket[]|null
     */
    public function getWsSupportTicket()
    {
        return isset($this->WsSupportTicket) ? $this->WsSupportTicket : null;
    }
    /**
     * This method is responsible for validating the values passed to the setWsSupportTicket method
     * This method is willingly generated in order to preserve the one-line inline validation within the setWsSupportTicket method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateWsSupportTicketForArrayConstraintsFromSetWsSupportTicket(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfWsSupportTicketWsSupportTicketItem) {
            // validation for constraint: itemType
            if (!$arrayOfWsSupportTicketWsSupportTicketItem instanceof \StructType\WsSupportTicket) {
                $invalidValues[] = is_object($arrayOfWsSupportTicketWsSupportTicketItem) ? get_class($arrayOfWsSupportTicketWsSupportTicketItem) : sprintf('%s(%s)', gettype($arrayOfWsSupportTicketWsSupportTicketItem), var_export($arrayOfWsSupportTicketWsSupportTicketItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The WsSupportTicket property can only contain items of type \StructType\WsSupportTicket, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set WsSupportTicket value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\WsSupportTicket[] $wsSupportTicket
     * @return \ArrayType\ArrayOfWsSupportTicket
     */
    public function setWsSupportTicket(array $wsSupportTicket = array())
    {
        // validation for constraint: array
        if ('' !== ($wsSupportTicketArrayErrorMessage = self::validateWsSupportTicketForArrayConstraintsFromSetWsSupportTicket($wsSupportTicket))) {
            throw new \InvalidArgumentException($wsSupportTicketArrayErrorMessage, __LINE__);
        }
        if (is_null($wsSupportTicket) || (is_array($wsSupportTicket) && empty($wsSupportTicket))) {
            unset($this->WsSupportTicket);
        } else {
            $this->WsSupportTicket = $wsSupportTicket;
        }
        return $this;
    }
    /**
     * Add item to WsSupportTicket value
     * @throws \InvalidArgumentException
     * @param \StructType\WsSupportTicket $item
     * @return \ArrayType\ArrayOfWsSupportTicket
     */
    public function addToWsSupportTicket(\StructType\WsSupportTicket $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\WsSupportTicket) {
            throw new \InvalidArgumentException(sprintf('The WsSupportTicket property can only contain items of type \StructType\WsSupportTicket, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->WsSupportTicket[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\WsSupportTicket|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\WsSupportTicket|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\WsSupportTicket|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\WsSupportTicket|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\WsSupportTicket|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string WsSupportTicket
     */
    public function getAttributeName()
    {
        return 'WsSupportTicket';
    }
}
