<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'GetWizardWebResponse' => '\\StructType\\GetWizardWebResponse',
            'GetWizardWebResponseInput' => '\\StructType\\GetWizardWebResponseInput',
            'ArrayOfString' => '\\ArrayType\\ArrayOfString',
            'GetWizardWebResponseResponse' => '\\StructType\\GetWizardWebResponseResponse',
            'GetWizardWebResponseOutput' => '\\StructType\\GetWizardWebResponseOutput',
            'Authentication' => '\\StructType\\Authentication',
            'GetRepList' => '\\StructType\\GetRepList',
            'GetRepListResponse' => '\\StructType\\GetRepListResponse',
            'ArrayOfRep' => '\\ArrayType\\ArrayOfRep',
            'Rep' => '\\StructType\\Rep',
            'AddressWithName' => '\\StructType\\AddressWithName',
            'Address' => '\\StructType\\Address',
            'AddressWithCoordinates' => '\\StructType\\AddressWithCoordinates',
            'ArrayOfRepRole' => '\\ArrayType\\ArrayOfRepRole',
            'RepRole' => '\\StructType\\RepRole',
            'GetRepListForDealer' => '\\StructType\\GetRepListForDealer',
            'GetRepListForDealerInput' => '\\StructType\\GetRepListForDealerInput',
            'GetRepListForDealerResponse' => '\\StructType\\GetRepListForDealerResponse',
            'GetPanelTemplateIds' => '\\StructType\\GetPanelTemplateIds',
            'GetPanelTemplateIdsResponse' => '\\StructType\\GetPanelTemplateIdsResponse',
            'GetPanelTemplateIdsOutput' => '\\StructType\\GetPanelTemplateIdsOutput',
            'ArrayOfPanelTemplateInfo' => '\\ArrayType\\ArrayOfPanelTemplateInfo',
            'PanelTemplateInfo' => '\\StructType\\PanelTemplateInfo',
            'GetPackageIds' => '\\StructType\\GetPackageIds',
            'GetPackageIdsInput' => '\\StructType\\GetPackageIdsInput',
            'GetPackageIdsResponse' => '\\StructType\\GetPackageIdsResponse',
            'GetPackageIdsOutput' => '\\StructType\\GetPackageIdsOutput',
            'ArrayOfPackageInfo' => '\\ArrayType\\ArrayOfPackageInfo',
            'PackageInfo' => '\\StructType\\PackageInfo',
            'ArrayOfAddOnFeatureInfo' => '\\ArrayType\\ArrayOfAddOnFeatureInfo',
            'AddOnFeatureInfo' => '\\StructType\\AddOnFeatureInfo',
            'GetCustomPackageTemplates' => '\\StructType\\GetCustomPackageTemplates',
            'GetCustomPackageTemplatesResponse' => '\\StructType\\GetCustomPackageTemplatesResponse',
            'GetCustomPackageTemplatesOutput' => '\\StructType\\GetCustomPackageTemplatesOutput',
            'ArrayOfPackageTemplate' => '\\ArrayType\\ArrayOfPackageTemplate',
            'PackageTemplate' => '\\StructType\\PackageTemplate',
            'GetCustomPackageTemplatesV2' => '\\StructType\\GetCustomPackageTemplatesV2',
            'GetCustomPackageTemplatesV2Input' => '\\StructType\\GetCustomPackageTemplatesV2Input',
            'GetCustomPackageTemplatesV2Response' => '\\StructType\\GetCustomPackageTemplatesV2Response',
            'GetCustomPackageTemplatesV2Output' => '\\StructType\\GetCustomPackageTemplatesV2Output',
            'TerminateRep' => '\\StructType\\TerminateRep',
            'TerminateRepInput' => '\\StructType\\TerminateRepInput',
            'TerminateRepResponse' => '\\StructType\\TerminateRepResponse',
            'TerminateRepOutput' => '\\StructType\\TerminateRepOutput',
            'CreateRepLogin' => '\\StructType\\CreateRepLogin',
            'CreateRepLoginInput' => '\\StructType\\CreateRepLoginInput',
            'ArrayOfInt' => '\\ArrayType\\ArrayOfInt',
            'ArrayOfCustomerRepDepartmentEnum' => '\\ArrayType\\ArrayOfCustomerRepDepartmentEnum',
            'ArrayOfDealerMarketingEmailPreferenceEnum' => '\\ArrayType\\ArrayOfDealerMarketingEmailPreferenceEnum',
            'CreateRepLoginResponse' => '\\StructType\\CreateRepLoginResponse',
            'CreateRepLoginOutput' => '\\StructType\\CreateRepLoginOutput',
            'CreateBranch' => '\\StructType\\CreateBranch',
            'CreateBranchInput' => '\\StructType\\CreateBranchInput',
            'CreateBranchResponse' => '\\StructType\\CreateBranchResponse',
            'CreateBranchOutput' => '\\StructType\\CreateBranchOutput',
            'DuplicateBranch' => '\\StructType\\DuplicateBranch',
            'DuplicateBranchInput' => '\\StructType\\DuplicateBranchInput',
            'DuplicateBranchResponse' => '\\StructType\\DuplicateBranchResponse',
            'UpdateRepLogin' => '\\StructType\\UpdateRepLogin',
            'UpdateRepLoginInput' => '\\StructType\\UpdateRepLoginInput',
            'UpdateRepLoginResponse' => '\\StructType\\UpdateRepLoginResponse',
            'UpdateRepLoginOutput' => '\\StructType\\UpdateRepLoginOutput',
            'ResetRepPassword' => '\\StructType\\ResetRepPassword',
            'ResetRepPasswordInput' => '\\StructType\\ResetRepPasswordInput',
            'ResetRepPasswordResponse' => '\\StructType\\ResetRepPasswordResponse',
            'ResetRepPasswordOutput' => '\\StructType\\ResetRepPasswordOutput',
            'CreateSeamlessLoginTokenForRep' => '\\StructType\\CreateSeamlessLoginTokenForRep',
            'CreateSeamlessLoginTokenForRepResponse' => '\\StructType\\CreateSeamlessLoginTokenForRepResponse',
            'CreateSeamlessLoginTokenForRepOutput' => '\\StructType\\CreateSeamlessLoginTokenForRepOutput',
            'GetRepRoles' => '\\StructType\\GetRepRoles',
            'GetRepRolesResponse' => '\\StructType\\GetRepRolesResponse',
            'GetCurrentRepInfo' => '\\StructType\\GetCurrentRepInfo',
            'GetCurrentRepInfoInput' => '\\StructType\\GetCurrentRepInfoInput',
            'GetCurrentRepInfoResponse' => '\\StructType\\GetCurrentRepInfoResponse',
            'GetCurrentRepInfoOutput' => '\\StructType\\GetCurrentRepInfoOutput',
            'GetDealerId' => '\\StructType\\GetDealerId',
            'GetDealerIdResponse' => '\\StructType\\GetDealerIdResponse',
            'GetDealerIdOutput' => '\\StructType\\GetDealerIdOutput',
            'ArrayOfBranchInfo' => '\\ArrayType\\ArrayOfBranchInfo',
            'BranchInfo' => '\\StructType\\BranchInfo',
            'SetIpMaskRestriction' => '\\StructType\\SetIpMaskRestriction',
            'SetIpMaskRestrictionInput' => '\\StructType\\SetIpMaskRestrictionInput',
            'SetIpMaskRestrictionResponse' => '\\StructType\\SetIpMaskRestrictionResponse',
            'SetIpMaskRestrictionOutput' => '\\StructType\\SetIpMaskRestrictionOutput',
            'GetBranch' => '\\StructType\\GetBranch',
            'GetBranchResponse' => '\\StructType\\GetBranchResponse',
            'GetBranches' => '\\StructType\\GetBranches',
            'GetBranchesResponse' => '\\StructType\\GetBranchesResponse',
            'GetSupportedPanelTypes' => '\\StructType\\GetSupportedPanelTypes',
            'GetSupportedPanelTypesResponse' => '\\StructType\\GetSupportedPanelTypesResponse',
            'ArrayOfPanelTypeEnum' => '\\ArrayType\\ArrayOfPanelTypeEnum',
            'GetPanelVersionMappings' => '\\StructType\\GetPanelVersionMappings',
            'GetPanelVersionMappingsResponse' => '\\StructType\\GetPanelVersionMappingsResponse',
            'ArrayOfPanelVersion' => '\\ArrayType\\ArrayOfPanelVersion',
            'PanelVersion' => '\\StructType\\PanelVersion',
            'CheckAvailableLoginName' => '\\StructType\\CheckAvailableLoginName',
            'CheckAvailableLoginNameResponse' => '\\StructType\\CheckAvailableLoginNameResponse',
            'CheckAvailableLoginNameOutput' => '\\StructType\\CheckAvailableLoginNameOutput',
            'GenerateRepLoginTokenForSSO' => '\\StructType\\GenerateRepLoginTokenForSSO',
            'GenerateRepLoginTokenForSSOInput' => '\\StructType\\GenerateRepLoginTokenForSSOInput',
            'GenerateRepLoginTokenForSSOResponse' => '\\StructType\\GenerateRepLoginTokenForSSOResponse',
            'GenerateRepLoginTokenForSSOOutput' => '\\StructType\\GenerateRepLoginTokenForSSOOutput',
            'GenerateRepLoginUrlForSSOMobileTechApp' => '\\StructType\\GenerateRepLoginUrlForSSOMobileTechApp',
            'GenerateRepLoginUrlForSSOMobileTechAppInput' => '\\StructType\\GenerateRepLoginUrlForSSOMobileTechAppInput',
            'BaseGenerateRepLoginUrlForSSOMobileTechAppInput' => '\\StructType\\BaseGenerateRepLoginUrlForSSOMobileTechAppInput',
            'GenerateRepLoginUrlForSSOMobileTechAppResponse' => '\\StructType\\GenerateRepLoginUrlForSSOMobileTechAppResponse',
            'GenerateRepLoginUrlForSSOMobileTechAppOutput' => '\\StructType\\GenerateRepLoginUrlForSSOMobileTechAppOutput',
            'GrantTemporaryAccessForRep' => '\\StructType\\GrantTemporaryAccessForRep',
            'GrantTemporaryAccessForRepInput' => '\\StructType\\GrantTemporaryAccessForRepInput',
            'GrantTemporaryAccessForRepResponse' => '\\StructType\\GrantTemporaryAccessForRepResponse',
            'GrantTemporaryAccessForRepOutput' => '\\StructType\\GrantTemporaryAccessForRepOutput',
            'RevokeTemporaryAccessForRep' => '\\StructType\\RevokeTemporaryAccessForRep',
            'RevokeTemporaryAccessForRepInput' => '\\StructType\\RevokeTemporaryAccessForRepInput',
            'RevokeTemporaryAccessForRepResponse' => '\\StructType\\RevokeTemporaryAccessForRepResponse',
            'RevokeTemporaryAccessForRepOutput' => '\\StructType\\RevokeTemporaryAccessForRepOutput',
            'GetRepIdByEmployeeId' => '\\StructType\\GetRepIdByEmployeeId',
            'GetRepIdByEmployeeIdInput' => '\\StructType\\GetRepIdByEmployeeIdInput',
            'GetRepIdByEmployeeIdResponse' => '\\StructType\\GetRepIdByEmployeeIdResponse',
            'GetRepIdByEmployeeIdOutput' => '\\StructType\\GetRepIdByEmployeeIdOutput',
            'GetCustomerUnsubscribes' => '\\StructType\\GetCustomerUnsubscribes',
            'GetCustomerUnsubscribesResponse' => '\\StructType\\GetCustomerUnsubscribesResponse',
            'GetCustomerUnsubscribesOutput' => '\\StructType\\GetCustomerUnsubscribesOutput',
            'ArrayOfCustomerUnsubscribes' => '\\ArrayType\\ArrayOfCustomerUnsubscribes',
            'CustomerUnsubscribes' => '\\StructType\\CustomerUnsubscribes',
            'GetCustomerUnsubscribesForDealer' => '\\StructType\\GetCustomerUnsubscribesForDealer',
            'GetCustomerUnsubscribesInput' => '\\StructType\\GetCustomerUnsubscribesInput',
            'GetCustomerUnsubscribesForDealerResponse' => '\\StructType\\GetCustomerUnsubscribesForDealerResponse',
            'GetBuilderPrograms' => '\\StructType\\GetBuilderPrograms',
            'GetBuilderProgramsResponse' => '\\StructType\\GetBuilderProgramsResponse',
            'GetBuilderProgramsOutput' => '\\StructType\\GetBuilderProgramsOutput',
            'ArrayOfBuilderProgramInfo' => '\\ArrayType\\ArrayOfBuilderProgramInfo',
            'BuilderProgramInfo' => '\\StructType\\BuilderProgramInfo',
            'GetBinderContents' => '\\StructType\\GetBinderContents',
            'GetBinderContentsResponse' => '\\StructType\\GetBinderContentsResponse',
            'GetBinderContentsOutput' => '\\StructType\\GetBinderContentsOutput',
            'ArrayOfMyBinderResourceItemModel' => '\\ArrayType\\ArrayOfMyBinderResourceItemModel',
            'MyBinderResourceItemModel' => '\\StructType\\MyBinderResourceItemModel',
            'AddToBinder' => '\\StructType\\AddToBinder',
            'AddToBinderInput' => '\\StructType\\AddToBinderInput',
            'AddToBinderResponse' => '\\StructType\\AddToBinderResponse',
            'AddToBinderOutput' => '\\StructType\\AddToBinderOutput',
            'AssignTrainingPathToRep' => '\\StructType\\AssignTrainingPathToRep',
            'AssignTrainingPathToRepInput' => '\\StructType\\AssignTrainingPathToRepInput',
            'AssignTrainingPathToRepResponse' => '\\StructType\\AssignTrainingPathToRepResponse',
            'AssignTrainingPathToRepOutput' => '\\StructType\\AssignTrainingPathToRepOutput',
            'GetSupportTickets' => '\\StructType\\GetSupportTickets',
            'GetSupportTicketsInput' => '\\StructType\\GetSupportTicketsInput',
            'GetSupportTicketsResponse' => '\\StructType\\GetSupportTicketsResponse',
            'GetSupportTicketsOutput' => '\\StructType\\GetSupportTicketsOutput',
            'ArrayOfWsSupportTicket' => '\\ArrayType\\ArrayOfWsSupportTicket',
            'WsSupportTicket' => '\\StructType\\WsSupportTicket',
            'CreateSupportTicket' => '\\StructType\\CreateSupportTicket',
            'CreateSupportTicketInput' => '\\StructType\\CreateSupportTicketInput',
            'CreateSupportTicketResponse' => '\\StructType\\CreateSupportTicketResponse',
            'CreateSupportTicketOutput' => '\\StructType\\CreateSupportTicketOutput',
            'CreateSupportTicketForDealer' => '\\StructType\\CreateSupportTicketForDealer',
            'CreateSupportTicketForDealerInput' => '\\StructType\\CreateSupportTicketForDealerInput',
            'CreateSupportTicketForDealerResponse' => '\\StructType\\CreateSupportTicketForDealerResponse',
            'UpdateSupportTicket' => '\\StructType\\UpdateSupportTicket',
            'UpdateSupportTicketInput' => '\\StructType\\UpdateSupportTicketInput',
            'UpdateSupportTicketResponse' => '\\StructType\\UpdateSupportTicketResponse',
            'UpdateSupportTicketOutput' => '\\StructType\\UpdateSupportTicketOutput',
            'UpdateSupportTicketForDealer' => '\\StructType\\UpdateSupportTicketForDealer',
            'UpdateSupportTicketForDealerInput' => '\\StructType\\UpdateSupportTicketForDealerInput',
            'UpdateSupportTicketForDealerResponse' => '\\StructType\\UpdateSupportTicketForDealerResponse',
            'GetSupportTicketCategories' => '\\StructType\\GetSupportTicketCategories',
            'GetSupportTicketCategoriesResponse' => '\\StructType\\GetSupportTicketCategoriesResponse',
            'GetSupportTicketCategoriesOutput' => '\\StructType\\GetSupportTicketCategoriesOutput',
            'ArrayOfWsIssueCategory' => '\\ArrayType\\ArrayOfWsIssueCategory',
            'WsIssueCategory' => '\\StructType\\WsIssueCategory',
            'GetSupportTicketComments' => '\\StructType\\GetSupportTicketComments',
            'GetSupportTicketCommentsResponse' => '\\StructType\\GetSupportTicketCommentsResponse',
            'GetSupportTicketCommentsOutput' => '\\StructType\\GetSupportTicketCommentsOutput',
            'ArrayOfWsIssueComment' => '\\ArrayType\\ArrayOfWsIssueComment',
            'WsIssueComment' => '\\StructType\\WsIssueComment',
            'GetCSPhoneNumber' => '\\StructType\\GetCSPhoneNumber',
            'GetCSPhoneNumberResponse' => '\\StructType\\GetCSPhoneNumberResponse',
            'GetCSPhoneNumberOutput' => '\\StructType\\GetCSPhoneNumberOutput',
            'ArrayOfWsCSPhone' => '\\ArrayType\\ArrayOfWsCSPhone',
            'WsCSPhone' => '\\StructType\\WsCSPhone',
            'GetExtendedDealerFileUploadsForDealer' => '\\StructType\\GetExtendedDealerFileUploadsForDealer',
            'GetExtendedDealerFileUploadsForDealerResponse' => '\\StructType\\GetExtendedDealerFileUploadsForDealerResponse',
            'GetExtendedDealerFileUploadsForDealerOutput' => '\\StructType\\GetExtendedDealerFileUploadsForDealerOutput',
            'ArrayOfDealerCustomUpload' => '\\ArrayType\\ArrayOfDealerCustomUpload',
            'DealerCustomUpload' => '\\StructType\\DealerCustomUpload',
            'GetExtendedDealerFileUpload' => '\\StructType\\GetExtendedDealerFileUpload',
            'GetExtendedDealerFileUploadResponse' => '\\StructType\\GetExtendedDealerFileUploadResponse',
            'GetExtendedDealerFileUploadOutput' => '\\StructType\\GetExtendedDealerFileUploadOutput',
            'DeleteExtendedDealerFile' => '\\StructType\\DeleteExtendedDealerFile',
            'DeleteExtendedDealerFileResponse' => '\\StructType\\DeleteExtendedDealerFileResponse',
            'DeleteExtendedDealerFileOutput' => '\\StructType\\DeleteExtendedDealerFileOutput',
            'GetExtendedDealerErrorFile' => '\\StructType\\GetExtendedDealerErrorFile',
            'GetExtendedDealerErrorFileResponse' => '\\StructType\\GetExtendedDealerErrorFileResponse',
            'GetExtendedDealerErrorFileOutput' => '\\StructType\\GetExtendedDealerErrorFileOutput',
        );
    }
}
