<?php

namespace EnumType;

use \WsdlToPhp\PackageBase\AbstractStructEnumBase;

/**
 * This class stands for IssueOriginEnum EnumType
 * @subpackage Enumerations
 */
class IssueOriginEnum extends AbstractStructEnumBase
{
    /**
     * Constant for value 'WebsiteSubmission'
     * @return string 'WebsiteSubmission'
     */
    const VALUE_WEBSITE_SUBMISSION = 'WebsiteSubmission';
    /**
     * Constant for value 'EmailToSupportAtAlarmDotCom'
     * @return string 'EmailToSupportAtAlarmDotCom'
     */
    const VALUE_EMAIL_TO_SUPPORT_AT_ALARM_DOT_COM = 'EmailToSupportAtAlarmDotCom';
    /**
     * Constant for value 'Phone'
     * @return string 'Phone'
     */
    const VALUE_PHONE = 'Phone';
    /**
     * Constant for value 'OtherEmail'
     * @return string 'OtherEmail'
     */
    const VALUE_OTHER_EMAIL = 'OtherEmail';
    /**
     * Constant for value 'MobileApp'
     * @return string 'MobileApp'
     */
    const VALUE_MOBILE_APP = 'MobileApp';
    /**
     * Constant for value 'Internal'
     * @return string 'Internal'
     */
    const VALUE_INTERNAL = 'Internal';
    /**
     * Constant for value 'PhoneFromCustomer'
     * @return string 'PhoneFromCustomer'
     */
    const VALUE_PHONE_FROM_CUSTOMER = 'PhoneFromCustomer';
    /**
     * Constant for value 'EmailFromCustomer'
     * @return string 'EmailFromCustomer'
     */
    const VALUE_EMAIL_FROM_CUSTOMER = 'EmailFromCustomer';
    /**
     * Constant for value 'SocialMediaFacebook'
     * @return string 'SocialMediaFacebook'
     */
    const VALUE_SOCIAL_MEDIA_FACEBOOK = 'SocialMediaFacebook';
    /**
     * Constant for value 'SocialMediaTwitter'
     * @return string 'SocialMediaTwitter'
     */
    const VALUE_SOCIAL_MEDIA_TWITTER = 'SocialMediaTwitter';
    /**
     * Constant for value 'SupportChat'
     * @return string 'SupportChat'
     */
    const VALUE_SUPPORT_CHAT = 'SupportChat';
    /**
     * Constant for value 'MobileTech'
     * @return string 'MobileTech'
     */
    const VALUE_MOBILE_TECH = 'MobileTech';
    /**
     * Constant for value 'MobileTechCallbackRequest'
     * @return string 'MobileTechCallbackRequest'
     */
    const VALUE_MOBILE_TECH_CALLBACK_REQUEST = 'MobileTechCallbackRequest';
    /**
     * Constant for value 'WebsiteSubmissionOrMobileApp_ContactUsForm'
     * @return string 'WebsiteSubmissionOrMobileApp_ContactUsForm'
     */
    const VALUE_WEBSITE_SUBMISSION_OR_MOBILE_APP_CONTACT_US_FORM = 'WebsiteSubmissionOrMobileApp_ContactUsForm';
    /**
     * Constant for value 'CustomerSurvey'
     * @return string 'CustomerSurvey'
     */
    const VALUE_CUSTOMER_SURVEY = 'CustomerSurvey';
    /**
     * Constant for value 'AutomaticallyGenerated'
     * @return string 'AutomaticallyGenerated'
     */
    const VALUE_AUTOMATICALLY_GENERATED = 'AutomaticallyGenerated';
    /**
     * Constant for value 'NameChangeRequest'
     * @return string 'NameChangeRequest'
     */
    const VALUE_NAME_CHANGE_REQUEST = 'NameChangeRequest';
    /**
     * Return allowed values
     * @uses self::VALUE_WEBSITE_SUBMISSION
     * @uses self::VALUE_EMAIL_TO_SUPPORT_AT_ALARM_DOT_COM
     * @uses self::VALUE_PHONE
     * @uses self::VALUE_OTHER_EMAIL
     * @uses self::VALUE_MOBILE_APP
     * @uses self::VALUE_INTERNAL
     * @uses self::VALUE_PHONE_FROM_CUSTOMER
     * @uses self::VALUE_EMAIL_FROM_CUSTOMER
     * @uses self::VALUE_SOCIAL_MEDIA_FACEBOOK
     * @uses self::VALUE_SOCIAL_MEDIA_TWITTER
     * @uses self::VALUE_SUPPORT_CHAT
     * @uses self::VALUE_MOBILE_TECH
     * @uses self::VALUE_MOBILE_TECH_CALLBACK_REQUEST
     * @uses self::VALUE_WEBSITE_SUBMISSION_OR_MOBILE_APP_CONTACT_US_FORM
     * @uses self::VALUE_CUSTOMER_SURVEY
     * @uses self::VALUE_AUTOMATICALLY_GENERATED
     * @uses self::VALUE_NAME_CHANGE_REQUEST
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_WEBSITE_SUBMISSION,
            self::VALUE_EMAIL_TO_SUPPORT_AT_ALARM_DOT_COM,
            self::VALUE_PHONE,
            self::VALUE_OTHER_EMAIL,
            self::VALUE_MOBILE_APP,
            self::VALUE_INTERNAL,
            self::VALUE_PHONE_FROM_CUSTOMER,
            self::VALUE_EMAIL_FROM_CUSTOMER,
            self::VALUE_SOCIAL_MEDIA_FACEBOOK,
            self::VALUE_SOCIAL_MEDIA_TWITTER,
            self::VALUE_SUPPORT_CHAT,
            self::VALUE_MOBILE_TECH,
            self::VALUE_MOBILE_TECH_CALLBACK_REQUEST,
            self::VALUE_WEBSITE_SUBMISSION_OR_MOBILE_APP_CONTACT_US_FORM,
            self::VALUE_CUSTOMER_SURVEY,
            self::VALUE_AUTOMATICALLY_GENERATED,
            self::VALUE_NAME_CHANGE_REQUEST,
        );
    }
}
