<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetCSPhoneNumberOutput StructType
 * @subpackage Structs
 */
class GetCSPhoneNumberOutput extends AbstractStructBase
{
    /**
     * The Success
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $Success;
    /**
     * The CSPhones
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfWsCSPhone
     */
    public $CSPhones;
    /**
     * The ErrorMessage
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ErrorMessage;
    /**
     * Constructor method for GetCSPhoneNumberOutput
     * @uses GetCSPhoneNumberOutput::setSuccess()
     * @uses GetCSPhoneNumberOutput::setCSPhones()
     * @uses GetCSPhoneNumberOutput::setErrorMessage()
     * @param bool $success
     * @param \ArrayType\ArrayOfWsCSPhone $cSPhones
     * @param string $errorMessage
     */
    public function __construct($success = null, \ArrayType\ArrayOfWsCSPhone $cSPhones = null, $errorMessage = null)
    {
        $this
            ->setSuccess($success)
            ->setCSPhones($cSPhones)
            ->setErrorMessage($errorMessage);
    }
    /**
     * Get Success value
     * @return bool
     */
    public function getSuccess()
    {
        return $this->Success;
    }
    /**
     * Set Success value
     * @param bool $success
     * @return \StructType\GetCSPhoneNumberOutput
     */
    public function setSuccess($success = null)
    {
        // validation for constraint: boolean
        if (!is_null($success) && !is_bool($success)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($success, true), gettype($success)), __LINE__);
        }
        $this->Success = $success;
        return $this;
    }
    /**
     * Get CSPhones value
     * @return \ArrayType\ArrayOfWsCSPhone|null
     */
    public function getCSPhones()
    {
        return $this->CSPhones;
    }
    /**
     * Set CSPhones value
     * @param \ArrayType\ArrayOfWsCSPhone $cSPhones
     * @return \StructType\GetCSPhoneNumberOutput
     */
    public function setCSPhones(\ArrayType\ArrayOfWsCSPhone $cSPhones = null)
    {
        $this->CSPhones = $cSPhones;
        return $this;
    }
    /**
     * Get ErrorMessage value
     * @return string|null
     */
    public function getErrorMessage()
    {
        return $this->ErrorMessage;
    }
    /**
     * Set ErrorMessage value
     * @param string $errorMessage
     * @return \StructType\GetCSPhoneNumberOutput
     */
    public function setErrorMessage($errorMessage = null)
    {
        // validation for constraint: string
        if (!is_null($errorMessage) && !is_string($errorMessage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($errorMessage, true), gettype($errorMessage)), __LINE__);
        }
        $this->ErrorMessage = $errorMessage;
        return $this;
    }
}
