<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetExtendedDealerFileUploadsForDealerOutput StructType
 * @subpackage Structs
 */
class GetExtendedDealerFileUploadsForDealerOutput extends AbstractStructBase
{
    /**
     * The Success
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $Success;
    /**
     * The ErrorMessage
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ErrorMessage;
    /**
     * The Files
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfDealerCustomUpload
     */
    public $Files;
    /**
     * Constructor method for GetExtendedDealerFileUploadsForDealerOutput
     * @uses GetExtendedDealerFileUploadsForDealerOutput::setSuccess()
     * @uses GetExtendedDealerFileUploadsForDealerOutput::setErrorMessage()
     * @uses GetExtendedDealerFileUploadsForDealerOutput::setFiles()
     * @param bool $success
     * @param string $errorMessage
     * @param \ArrayType\ArrayOfDealerCustomUpload $files
     */
    public function __construct($success = null, $errorMessage = null, \ArrayType\ArrayOfDealerCustomUpload $files = null)
    {
        $this
            ->setSuccess($success)
            ->setErrorMessage($errorMessage)
            ->setFiles($files);
    }
    /**
     * Get Success value
     * @return bool
     */
    public function getSuccess()
    {
        return $this->Success;
    }
    /**
     * Set Success value
     * @param bool $success
     * @return \StructType\GetExtendedDealerFileUploadsForDealerOutput
     */
    public function setSuccess($success = null)
    {
        // validation for constraint: boolean
        if (!is_null($success) && !is_bool($success)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($success, true), gettype($success)), __LINE__);
        }
        $this->Success = $success;
        return $this;
    }
    /**
     * Get ErrorMessage value
     * @return string|null
     */
    public function getErrorMessage()
    {
        return $this->ErrorMessage;
    }
    /**
     * Set ErrorMessage value
     * @param string $errorMessage
     * @return \StructType\GetExtendedDealerFileUploadsForDealerOutput
     */
    public function setErrorMessage($errorMessage = null)
    {
        // validation for constraint: string
        if (!is_null($errorMessage) && !is_string($errorMessage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($errorMessage, true), gettype($errorMessage)), __LINE__);
        }
        $this->ErrorMessage = $errorMessage;
        return $this;
    }
    /**
     * Get Files value
     * @return \ArrayType\ArrayOfDealerCustomUpload|null
     */
    public function getFiles()
    {
        return $this->Files;
    }
    /**
     * Set Files value
     * @param \ArrayType\ArrayOfDealerCustomUpload $files
     * @return \StructType\GetExtendedDealerFileUploadsForDealerOutput
     */
    public function setFiles(\ArrayType\ArrayOfDealerCustomUpload $files = null)
    {
        $this->Files = $files;
        return $this;
    }
}
