<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetSupportTicketCategoriesOutput StructType
 * @subpackage Structs
 */
class GetSupportTicketCategoriesOutput extends AbstractStructBase
{
    /**
     * The Success
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $Success;
    /**
     * The Categories
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfWsIssueCategory
     */
    public $Categories;
    /**
     * The ErrorMessage
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ErrorMessage;
    /**
     * Constructor method for GetSupportTicketCategoriesOutput
     * @uses GetSupportTicketCategoriesOutput::setSuccess()
     * @uses GetSupportTicketCategoriesOutput::setCategories()
     * @uses GetSupportTicketCategoriesOutput::setErrorMessage()
     * @param bool $success
     * @param \ArrayType\ArrayOfWsIssueCategory $categories
     * @param string $errorMessage
     */
    public function __construct($success = null, \ArrayType\ArrayOfWsIssueCategory $categories = null, $errorMessage = null)
    {
        $this
            ->setSuccess($success)
            ->setCategories($categories)
            ->setErrorMessage($errorMessage);
    }
    /**
     * Get Success value
     * @return bool
     */
    public function getSuccess()
    {
        return $this->Success;
    }
    /**
     * Set Success value
     * @param bool $success
     * @return \StructType\GetSupportTicketCategoriesOutput
     */
    public function setSuccess($success = null)
    {
        // validation for constraint: boolean
        if (!is_null($success) && !is_bool($success)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($success, true), gettype($success)), __LINE__);
        }
        $this->Success = $success;
        return $this;
    }
    /**
     * Get Categories value
     * @return \ArrayType\ArrayOfWsIssueCategory|null
     */
    public function getCategories()
    {
        return $this->Categories;
    }
    /**
     * Set Categories value
     * @param \ArrayType\ArrayOfWsIssueCategory $categories
     * @return \StructType\GetSupportTicketCategoriesOutput
     */
    public function setCategories(\ArrayType\ArrayOfWsIssueCategory $categories = null)
    {
        $this->Categories = $categories;
        return $this;
    }
    /**
     * Get ErrorMessage value
     * @return string|null
     */
    public function getErrorMessage()
    {
        return $this->ErrorMessage;
    }
    /**
     * Set ErrorMessage value
     * @param string $errorMessage
     * @return \StructType\GetSupportTicketCategoriesOutput
     */
    public function setErrorMessage($errorMessage = null)
    {
        // validation for constraint: string
        if (!is_null($errorMessage) && !is_string($errorMessage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($errorMessage, true), gettype($errorMessage)), __LINE__);
        }
        $this->ErrorMessage = $errorMessage;
        return $this;
    }
}
