<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetSupportTicketCommentsOutput StructType
 * @subpackage Structs
 */
class GetSupportTicketCommentsOutput extends AbstractStructBase
{
    /**
     * The Success
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $Success;
    /**
     * The TicketComments
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfWsIssueComment
     */
    public $TicketComments;
    /**
     * The ErrorMessage
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ErrorMessage;
    /**
     * Constructor method for GetSupportTicketCommentsOutput
     * @uses GetSupportTicketCommentsOutput::setSuccess()
     * @uses GetSupportTicketCommentsOutput::setTicketComments()
     * @uses GetSupportTicketCommentsOutput::setErrorMessage()
     * @param bool $success
     * @param \ArrayType\ArrayOfWsIssueComment $ticketComments
     * @param string $errorMessage
     */
    public function __construct($success = null, \ArrayType\ArrayOfWsIssueComment $ticketComments = null, $errorMessage = null)
    {
        $this
            ->setSuccess($success)
            ->setTicketComments($ticketComments)
            ->setErrorMessage($errorMessage);
    }
    /**
     * Get Success value
     * @return bool
     */
    public function getSuccess()
    {
        return $this->Success;
    }
    /**
     * Set Success value
     * @param bool $success
     * @return \StructType\GetSupportTicketCommentsOutput
     */
    public function setSuccess($success = null)
    {
        // validation for constraint: boolean
        if (!is_null($success) && !is_bool($success)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($success, true), gettype($success)), __LINE__);
        }
        $this->Success = $success;
        return $this;
    }
    /**
     * Get TicketComments value
     * @return \ArrayType\ArrayOfWsIssueComment|null
     */
    public function getTicketComments()
    {
        return $this->TicketComments;
    }
    /**
     * Set TicketComments value
     * @param \ArrayType\ArrayOfWsIssueComment $ticketComments
     * @return \StructType\GetSupportTicketCommentsOutput
     */
    public function setTicketComments(\ArrayType\ArrayOfWsIssueComment $ticketComments = null)
    {
        $this->TicketComments = $ticketComments;
        return $this;
    }
    /**
     * Get ErrorMessage value
     * @return string|null
     */
    public function getErrorMessage()
    {
        return $this->ErrorMessage;
    }
    /**
     * Set ErrorMessage value
     * @param string $errorMessage
     * @return \StructType\GetSupportTicketCommentsOutput
     */
    public function setErrorMessage($errorMessage = null)
    {
        // validation for constraint: string
        if (!is_null($errorMessage) && !is_string($errorMessage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($errorMessage, true), gettype($errorMessage)), __LINE__);
        }
        $this->ErrorMessage = $errorMessage;
        return $this;
    }
}
