<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetSupportTicketsOutput StructType
 * @subpackage Structs
 */
class GetSupportTicketsOutput extends AbstractStructBase
{
    /**
     * The Success
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $Success;
    /**
     * The SupportTickets
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfWsSupportTicket
     */
    public $SupportTickets;
    /**
     * The ErrorMessage
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ErrorMessage;
    /**
     * Constructor method for GetSupportTicketsOutput
     * @uses GetSupportTicketsOutput::setSuccess()
     * @uses GetSupportTicketsOutput::setSupportTickets()
     * @uses GetSupportTicketsOutput::setErrorMessage()
     * @param bool $success
     * @param \ArrayType\ArrayOfWsSupportTicket $supportTickets
     * @param string $errorMessage
     */
    public function __construct($success = null, \ArrayType\ArrayOfWsSupportTicket $supportTickets = null, $errorMessage = null)
    {
        $this
            ->setSuccess($success)
            ->setSupportTickets($supportTickets)
            ->setErrorMessage($errorMessage);
    }
    /**
     * Get Success value
     * @return bool
     */
    public function getSuccess()
    {
        return $this->Success;
    }
    /**
     * Set Success value
     * @param bool $success
     * @return \StructType\GetSupportTicketsOutput
     */
    public function setSuccess($success = null)
    {
        // validation for constraint: boolean
        if (!is_null($success) && !is_bool($success)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($success, true), gettype($success)), __LINE__);
        }
        $this->Success = $success;
        return $this;
    }
    /**
     * Get SupportTickets value
     * @return \ArrayType\ArrayOfWsSupportTicket|null
     */
    public function getSupportTickets()
    {
        return $this->SupportTickets;
    }
    /**
     * Set SupportTickets value
     * @param \ArrayType\ArrayOfWsSupportTicket $supportTickets
     * @return \StructType\GetSupportTicketsOutput
     */
    public function setSupportTickets(\ArrayType\ArrayOfWsSupportTicket $supportTickets = null)
    {
        $this->SupportTickets = $supportTickets;
        return $this;
    }
    /**
     * Get ErrorMessage value
     * @return string|null
     */
    public function getErrorMessage()
    {
        return $this->ErrorMessage;
    }
    /**
     * Set ErrorMessage value
     * @param string $errorMessage
     * @return \StructType\GetSupportTicketsOutput
     */
    public function setErrorMessage($errorMessage = null)
    {
        // validation for constraint: string
        if (!is_null($errorMessage) && !is_string($errorMessage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($errorMessage, true), gettype($errorMessage)), __LINE__);
        }
        $this->ErrorMessage = $errorMessage;
        return $this;
    }
}
