<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for MyBinderResourceItemModel StructType
 * @subpackage Structs
 */
class MyBinderResourceItemModel extends AbstractStructBase
{
    /**
     * The RecipientRepId
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $RecipientRepId;
    /**
     * The ReceiveDateUtc
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $ReceiveDateUtc;
    /**
     * The Bookmarked
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $Bookmarked;
    /**
     * The Sender
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Sender;
    /**
     * The Title
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Title;
    /**
     * The Url
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Url;
    /**
     * Constructor method for MyBinderResourceItemModel
     * @uses MyBinderResourceItemModel::setRecipientRepId()
     * @uses MyBinderResourceItemModel::setReceiveDateUtc()
     * @uses MyBinderResourceItemModel::setBookmarked()
     * @uses MyBinderResourceItemModel::setSender()
     * @uses MyBinderResourceItemModel::setTitle()
     * @uses MyBinderResourceItemModel::setUrl()
     * @param int $recipientRepId
     * @param string $receiveDateUtc
     * @param bool $bookmarked
     * @param string $sender
     * @param string $title
     * @param string $url
     */
    public function __construct($recipientRepId = null, $receiveDateUtc = null, $bookmarked = null, $sender = null, $title = null, $url = null)
    {
        $this
            ->setRecipientRepId($recipientRepId)
            ->setReceiveDateUtc($receiveDateUtc)
            ->setBookmarked($bookmarked)
            ->setSender($sender)
            ->setTitle($title)
            ->setUrl($url);
    }
    /**
     * Get RecipientRepId value
     * @return int
     */
    public function getRecipientRepId()
    {
        return $this->RecipientRepId;
    }
    /**
     * Set RecipientRepId value
     * @param int $recipientRepId
     * @return \StructType\MyBinderResourceItemModel
     */
    public function setRecipientRepId($recipientRepId = null)
    {
        // validation for constraint: int
        if (!is_null($recipientRepId) && !(is_int($recipientRepId) || ctype_digit($recipientRepId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($recipientRepId, true), gettype($recipientRepId)), __LINE__);
        }
        $this->RecipientRepId = $recipientRepId;
        return $this;
    }
    /**
     * Get ReceiveDateUtc value
     * @return string
     */
    public function getReceiveDateUtc()
    {
        return $this->ReceiveDateUtc;
    }
    /**
     * Set ReceiveDateUtc value
     * @param string $receiveDateUtc
     * @return \StructType\MyBinderResourceItemModel
     */
    public function setReceiveDateUtc($receiveDateUtc = null)
    {
        // validation for constraint: string
        if (!is_null($receiveDateUtc) && !is_string($receiveDateUtc)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($receiveDateUtc, true), gettype($receiveDateUtc)), __LINE__);
        }
        $this->ReceiveDateUtc = $receiveDateUtc;
        return $this;
    }
    /**
     * Get Bookmarked value
     * @return bool
     */
    public function getBookmarked()
    {
        return $this->Bookmarked;
    }
    /**
     * Set Bookmarked value
     * @param bool $bookmarked
     * @return \StructType\MyBinderResourceItemModel
     */
    public function setBookmarked($bookmarked = null)
    {
        // validation for constraint: boolean
        if (!is_null($bookmarked) && !is_bool($bookmarked)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($bookmarked, true), gettype($bookmarked)), __LINE__);
        }
        $this->Bookmarked = $bookmarked;
        return $this;
    }
    /**
     * Get Sender value
     * @return string|null
     */
    public function getSender()
    {
        return $this->Sender;
    }
    /**
     * Set Sender value
     * @param string $sender
     * @return \StructType\MyBinderResourceItemModel
     */
    public function setSender($sender = null)
    {
        // validation for constraint: string
        if (!is_null($sender) && !is_string($sender)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sender, true), gettype($sender)), __LINE__);
        }
        $this->Sender = $sender;
        return $this;
    }
    /**
     * Get Title value
     * @return string|null
     */
    public function getTitle()
    {
        return $this->Title;
    }
    /**
     * Set Title value
     * @param string $title
     * @return \StructType\MyBinderResourceItemModel
     */
    public function setTitle($title = null)
    {
        // validation for constraint: string
        if (!is_null($title) && !is_string($title)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($title, true), gettype($title)), __LINE__);
        }
        $this->Title = $title;
        return $this;
    }
    /**
     * Get Url value
     * @return string|null
     */
    public function getUrl()
    {
        return $this->Url;
    }
    /**
     * Set Url value
     * @param string $url
     * @return \StructType\MyBinderResourceItemModel
     */
    public function setUrl($url = null)
    {
        // validation for constraint: string
        if (!is_null($url) && !is_string($url)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($url, true), gettype($url)), __LINE__);
        }
        $this->Url = $url;
        return $this;
    }
}
