<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UpdateSupportTicketOutput StructType
 * @subpackage Structs
 */
class UpdateSupportTicketOutput extends AbstractStructBase
{
    /**
     * The Success
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $Success;
    /**
     * The ErrorMessages
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfString
     */
    public $ErrorMessages;
    /**
     * The Messages
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfString
     */
    public $Messages;
    /**
     * Constructor method for UpdateSupportTicketOutput
     * @uses UpdateSupportTicketOutput::setSuccess()
     * @uses UpdateSupportTicketOutput::setErrorMessages()
     * @uses UpdateSupportTicketOutput::setMessages()
     * @param bool $success
     * @param \ArrayType\ArrayOfString $errorMessages
     * @param \ArrayType\ArrayOfString $messages
     */
    public function __construct($success = null, \ArrayType\ArrayOfString $errorMessages = null, \ArrayType\ArrayOfString $messages = null)
    {
        $this
            ->setSuccess($success)
            ->setErrorMessages($errorMessages)
            ->setMessages($messages);
    }
    /**
     * Get Success value
     * @return bool
     */
    public function getSuccess()
    {
        return $this->Success;
    }
    /**
     * Set Success value
     * @param bool $success
     * @return \StructType\UpdateSupportTicketOutput
     */
    public function setSuccess($success = null)
    {
        // validation for constraint: boolean
        if (!is_null($success) && !is_bool($success)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($success, true), gettype($success)), __LINE__);
        }
        $this->Success = $success;
        return $this;
    }
    /**
     * Get ErrorMessages value
     * @return \ArrayType\ArrayOfString|null
     */
    public function getErrorMessages()
    {
        return $this->ErrorMessages;
    }
    /**
     * Set ErrorMessages value
     * @param \ArrayType\ArrayOfString $errorMessages
     * @return \StructType\UpdateSupportTicketOutput
     */
    public function setErrorMessages(\ArrayType\ArrayOfString $errorMessages = null)
    {
        $this->ErrorMessages = $errorMessages;
        return $this;
    }
    /**
     * Get Messages value
     * @return \ArrayType\ArrayOfString|null
     */
    public function getMessages()
    {
        return $this->Messages;
    }
    /**
     * Set Messages value
     * @param \ArrayType\ArrayOfString $messages
     * @return \StructType\UpdateSupportTicketOutput
     */
    public function setMessages(\ArrayType\ArrayOfString $messages = null)
    {
        $this->Messages = $messages;
        return $this;
    }
}
